#!/usr/bin/env python2.5

# 
# Copyright (c) 2007-2008 INdT.
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

# ============================================================================
# Name        : musiQmem_plus1.py
# Author      : Group2
# Version     : 0.1
# Description : Python musiQmem +1 game
# ============================================================================


import gtk
import pygtk
#pygtk.require(2.0) 
import hildon
import select
import threading
import time
import media


class MusiQmem_plus1App(hildon.Program):
    def __init__(self):
        hildon.Program.__init__(self)

        self.window = hildon.Window()
        self.window.connect("delete_event", self.quit)  
        self.window.fullscreen()
        self.add_window(self.window)
        self.soundObject = media.PlaySound()
        self.imageHandler = media.ImageHandler()
        
        #table = gtk.Table(8,4,True)
                
        table = gtk.Table(80,48,True)
        self.label = gtk.Label("Don't push!!!")
        self.scoreTitle = gtk.Label("SCORE")
        self.scoreLabel = gtk.Label("PLAYER A: " + str(0) + "  ---- PLAYER B: " + str(1))
        
        self.turnText = gtk.Label("GAME INITIALIZING")
        self.turnCount = gtk.Label("TURN: 0+1")
        
        self.width = 100
        self.guitarButton = gtk.Button()
        #self.guitarButton.connect("released", self.playClick,("Guitar"))
        self.guitarButton.connect("pressed", self.playClick,("Guitar"))
        self.guitarButton.set_focus_on_click(False)
        
        self.drumButton = gtk.Button()
        self.drumButton.connect("pressed", self.playClick,("Drum"))
        self.drumButton.set_focus_on_click(False)
  
        self.pianoButton = gtk.Button()
        self.pianoButton.connect("pressed", self.playClick,("Piano"))
        self.pianoButton.set_focus_on_click(False)
  
        self.trumpetButton = gtk.Button()
        self.trumpetButton.connect("pressed", self.playClick,("Trumpet"))
        self.trumpetButton.set_focus_on_click(False)
  
        self.violinButton = gtk.Button()
        self.violinButton.connect("pressed", self.playClick,("Violin"))
        self.violinButton.set_focus_on_click(False)
        
        self.initButtonImages("normal", self.width)
  
        
        #table.attach(button,6,7,3,4)
        #table.attach(label,3,4,1,2)
        table.attach(self.guitarButton,5,17,50,77)
        table.attach(self.drumButton,20,32,50,77)
        table.attach(self.pianoButton,35,47,50,77)
        table.attach(self.trumpetButton,50,62,50,77)
        table.attach(self.violinButton,65,77,50,77)
        table.attach(self.label,20,50,0,10)
        table.attach(self.scoreTitle,50,77,0,10)
        table.attach(self.scoreLabel,50,77,11,22)
        table.attach(self.turnText,20,60,15,35)
        table.attach(self.turnCount,5,25,0,13)
    
        #self.guitarButton.show()
        #self.drumButton.show()
        #self.pianoButton.show()
        #self.trumpetButton.show()
        #self.violinButton.show()
        #self.label.show() 
        #self.scoreTitle.show()
        #self.scoreLabel.show()
        #self.turnText.show()
        #self.turnCount.show()
          
        
        self.window.add(table)
        #table.show()
        #self.window.show_all()
        #self.window.grab_focus()        
        #hoobox.pack_start(table2,True,True,0)
        #table2.show()
        list = [0,1,2,3,4,0,1,2,3,4,0,1,2,3,4,4,3,2,1,0]
        #list = [0,1,2,3]
        self.playThread = threading.Thread(target = self.playSequence, args = (list,))
        self.playThread.start()
        #self.playThread.start()


    def playClick(self, widget, data):
        self.playSound(data)

    def playSound(self, data):
        self.initButtonImages("red", self.width)
        self.label.set_text(data)
        self.soundObject.playInstrument(data)
        self.setButtonImage(data,"green",self.width)
        

    def parseInstrument(self, instrumentCode):
        i = instrumentCode
        if i == 0:
            return "Guitar"
        elif i == 1:
            return "Drum"
        elif i == 2:
            return "Piano"
        elif i == 3:
            return "Trumpet"
        elif i == 4:
            return "Violin"
        
    def playSequence(self, data):
        
      for i in data: 
        self.playSound(self.parseInstrument(i))
        #select.select([],[],[],0.5)
        select.select([],[],[],1.5)
            
    def initButtonImages(self, type, width):
        
        self.guitarButton.set_image(self.imageHandler.getImage("Guitar",type, width))
        self.drumButton.set_image(self.imageHandler.getImage("Drum",type, width))
        self.pianoButton.set_image(self.imageHandler.getImage("Piano",type, width))
        self.trumpetButton.set_image(self.imageHandler.getImage("Trumpet",type, width))
        self.violinButton.set_image(self.imageHandler.getImage("Violin",type, width))

    def setButtonImage(self, instrument, type, width):
        
        if instrument == "Guitar":
            self.guitarButton.set_image(self.imageHandler.getImage(instrument,type, width))
        elif instrument == "Drum":
            self.drumButton.set_image(self.imageHandler.getImage(instrument,type, width))
        elif instrument == "Piano":
            self.pianoButton.set_image(self.imageHandler.getImage(instrument,type, width))
        elif instrument == "Trumpet":
            self.trumpetButton.set_image(self.imageHandler.getImage(instrument,type, width))
        elif instrument == "Violin":
            self.violinButton.set_image(self.imageHandler.getImage(instrument,type, width))
  

    def quit(self, *args):
        print "Goodbye cruel world!"
        gtk.main_quit()
        
    def run(self):     
        self.window.show_all()
        gtk.gdk.threads_init()
        gtk.main() 

if __name__ == "__main__":  
    app = MusiQmem_plus1App() 
    app.run()         
